// DMM750Dlg.cpp : Implementierungsdatei
// Version: nonoverlapped

#include "stdafx.h"
#include "DMM750.h"
#include "DMM750Dlg.h"
#include "DisplayDlg.h"
#include <fstream.h>
#include "SaveDlg.h"
#include "SettingsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// fileglobale Variable: nur damit ist mit win98 auf 133Mhz-Pentium die
// Steuerung der Thread-Lebensdauer ohne Probleme zu machen. Die Verwendung
// eines Attributes Connect und einer Methode pDlg->Connect() fuehrt zu
// Laufzeit-Problemen!
static bool bCnnctd;

static BYTE aucDataBuff[4096];
static WORD wDataBuffIdx;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMM750Dlg Dialogfeld

CDMM750Dlg::CDMM750Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDMM750Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDMM750Dlg)
		// HINWEIS: Der Klassenassistent fgt hier Member-Initialisierung ein
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDMM750Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDMM750Dlg)
		// HINWEIS: Der Klassenassistent fgt an dieser Stelle DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDMM750Dlg, CDialog)
	//{{AFX_MSG_MAP(CDMM750Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTONSHOW, OnButtonshow)
	ON_BN_CLICKED(IDC_BUTTONSAVE, OnButtonsave)
	ON_BN_CLICKED(IDC_BUTTONRECEIVE, OnButtonreceive)
	ON_BN_CLICKED(IDC_BUTTONSETTINGS, OnButtonsettings)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMM750Dlg Nachrichten-Handler

BOOL CDMM750Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
  // das Display-Dialogfeld erzeugen
  m_dlgDisplay.Create(IDD_DISPLAY,this);
  // Start-Bitmap laden
  m_bmpBitmap.LoadBitmap(IDB_BM_START);
  m_bmpBitmap.GetObject(sizeof(m_bm),&m_bm);
  // und das Dialogfeld anzeigen
  m_dlgDisplay.ShowWindow(SW_SHOW);

  m_bmoAmpel.LoadBitmap(IDB_BITM_YELLOW);
  m_bmoAmpel.GetObject(sizeof(m_bmAmpel),&m_bmAmpel);

  m_sCfgFile = "DMM750.ini";
  // default Initialisierung
  m_sCOMPort="COM1";
  m_bFrame=TRUE;
  // Initialisierung aus config file
 ::fstream fCfgFile(m_sCfgFile,ios::in|ios::nocreate);
 char sBuff[10];
  if(fCfgFile.is_open()) {
    fCfgFile.getline(sBuff,10);
    m_sCOMPort = sBuff;
    fCfgFile.getline(sBuff,10);
	if(!strcmp(sBuff,"1")){
      m_bFrame = TRUE;
    }else{
      m_bFrame = FALSE;
    }
	fCfgFile.close();
  }

  bCnnctd=FALSE;

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CDMM750Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CDMM750Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);
    CDC dcMem;
    dcMem.CreateCompatibleDC(&dc);
    dcMem.SelectObject(&m_bmoAmpel);
    dc.BitBlt(6,6,m_bmAmpel.bmWidth,m_bmAmpel.bmHeight,&dcMem,0,0,SRCCOPY);

    CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CDMM750Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//---------------------------------------------------------------------------
bool CDMM750Dlg::GetDataFromFile(CString& _roFileName){
 bool result=false;
  ifstream fInData(_roFileName);
  if(fInData.is_open()){
    // einlesen bis zur 1. Druckzeile
    while(fInData.get()!=0x2e);   // 1d 40 1b 33 2e
    // 20 Druckzeilen
    for(int i=0;i<20;i++){
      while(fInData.get()!=0xa0); // 1b 2a 00 a0
      fInData.get();              // 00
      // eine Druckerzeile von 160 Bytes
      for(int j=0;j<160;j++){
        m_ucaPrinterLines[i][j]=(unsigned char)fInData.get();
      }
      if(fInData.get()!=0x0a){
        result=false;
        break;
      }else{
        result=true;
      }
    }
    fInData.close();
  }
  return result;
}

//---------------------------------------------------------------------------
bool CDMM750Dlg::GetDataFromBuffer(void){
 bool result=false;
 int nBIdx = 0; // Index im Rx buffer
  // einlesen bis zur 1. Druckzeile
  while(aucDataBuff[nBIdx++]!=0x2e);   // 1d 40 1b 33 2e
  // 20 Druckzeilen
  for(int i=0;i<20;i++){
    while(aucDataBuff[nBIdx++]!=0xa0); // 1b 2a 00 a0
    nBIdx++;              // 00
    // eine Druckerzeile von 160 Bytes
    for(int j=0;j<160;j++){
      m_ucaPrinterLines[i][j]=(unsigned char)aucDataBuff[nBIdx++];
    }
    if(aucDataBuff[nBIdx]!=0x0a){
      result=false;
      break;
    }else{
      result=true;
    }
  }
  return result;
}

//---------------------------------------------------------------------------
bool CDMM750Dlg::ConvertPrinterData2Pixels(void){
 bool result=false;
 unsigned char* pPxls=&m_ucaPixels[0];
 unsigned char ucBitMask; // markiert die Bitposition in der Druckerzeile
 unsigned char ucBitPos;  // wandert von 0x80->0x01 im gerade gebildeten
                          // Pixelbyte (Bitmapbyte)
 unsigned char ucByteCnt; // zaehlt mit, wie lange wir uns mit der Erzeugung
                          // eines Pixelbytes aus 8 Bitstellen von 8 Drucker-
                          // datenbytes beschaeftigen
 unsigned char ucPxlByte; // aus Druckerdaten gebildetes Bitmapbyte

  // ueber 20 Druckerzeilen
  for(int i=0;i<20;i++){
    ucBitMask=0x80; // MSB der Druckerbytes bilden 1. Scan line
    // ueber 8 "Bit lines" einer Druckerzeile
    for(int j=0;j<8;j++){
      ucPxlByte=0;
      ucByteCnt=0;
      ucBitPos=0x80;
      // ueber eine Bitposition innerhalb der Druckerzeile
      for(int k=0;k<160;k++){
        if(!(m_ucaPrinterLines[i][k]&ucBitMask)){
          ucPxlByte|=ucBitPos;  // Pixel setzen
        }
        ucByteCnt++;  // Bits im Pixelbyte zaehlen
        if(ucByteCnt>7){  // Pixelbyte fertig!
          *pPxls++=ucPxlByte;
          ucByteCnt=0;
          ucBitPos=0x80;
          ucPxlByte=0;
        }else{
          ucBitPos>>=1;
        }
      }
      ucBitMask>>=1;  // naechste Bitpos in Druckerzeile
      result=true;
    }
  }
  return result;
}

//---------------------------------------------------------------------------
void CDMM750Dlg::DrawFrame(void){
  // obere und untere Linie
  unsigned char* pUpperLine = &m_ucaPixels[0];
  unsigned char* pLowerLine = &m_ucaPixels[3180];
  for(int i=0;i<20;i++){
    *pUpperLine++ = *pLowerLine++ = 0;    
  }
  // linke und rechte Linie
  for(i=1;i<159;i++){
    m_ucaPixels[20*i] &= 0x7f;
    m_ucaPixels[20*i+19] &= 0xfe;
  }
}

//---------------------------------------------------------------------------
bool CDMM750Dlg::SaveBitmapInFile(CString& _roFileName){
 bool result=false;

 // Elemente des DIB files (Ezzell/Blaney S.851ff)
 BITMAPFILEHEADER oBmFh;
  oBmFh.bfType = 0x4d42;  // "BM"
  oBmFh.bfReserved1 = 0;
  oBmFh.bfReserved2 = 0;

 BITMAPINFOHEADER oBmIf;
  oBmIf.biSize = sizeof(oBmIf);
  oBmIf.biWidth = m_bm.bmWidth;
  oBmIf.biHeight = m_bm.bmHeight;
  oBmIf.biPlanes = 1;
  oBmIf.biBitCount = 1;
  oBmIf.biCompression = BI_RGB;
  oBmIf.biSizeImage = 0;
  oBmIf.biXPelsPerMeter = 0;
  oBmIf.biYPelsPerMeter = 0;
  oBmIf.biClrUsed = 0;
  oBmIf.biClrImportant = 0;

 struct{
  RGBQUAD foreground;
  RGBQUAD background;
 }oColourTab;
  oColourTab.foreground.rgbBlue=0;    // schwarz
  oColourTab.foreground.rgbGreen=0; 
  oColourTab.foreground.rgbRed=0;
  oColourTab.foreground.rgbReserved=0;
  oColourTab.background.rgbBlue=0xff; // weiss
  oColourTab.background.rgbGreen=0xff; 
  oColourTab.background.rgbRed=0xff;
  oColourTab.background.rgbReserved=0;

 unsigned char ucaPxlData[3200];
  // Scan lines umordnen
 int l = 0; // Laufindex in ucaPxlData
 int j;     // Laufindex in m_ucaPixels
  for(int i = 1;i <= 160;i++){ // 160 scan lines zu 20 bytes!
    j = 3200 - i*20;
    for(int k = 0;k<20;k++){
      ucaPxlData[l++] = m_ucaPixels[j++];
    }
  }

  oBmFh.bfSize = sizeof(oBmFh)+sizeof(oBmIf)+sizeof(oColourTab)+sizeof(ucaPxlData);
  oBmFh.bfOffBits = sizeof(oBmFh)+sizeof(oBmIf)+sizeof(oColourTab);

  ofstream fOutData(_roFileName);
  if(fOutData.is_open()){
    fOutData.write((char*)&oBmFh,sizeof(oBmFh));
    fOutData.write((char*)&oBmIf,sizeof(oBmIf));
    fOutData.write((char*)&oColourTab,sizeof(oColourTab));
    fOutData.write(ucaPxlData,3200);

    fOutData.close();
    result = true;
  }
  return result;
}

//---------------------------------------------------------------------------
void CDMM750Dlg::SaveSettings(void){
 ::fstream fCfgFile(m_sCfgFile,ios::out);
  if(fCfgFile.is_open()) {
    fCfgFile << m_sCOMPort << endl;
	if(m_bFrame){
      fCfgFile << "1" << endl;
    }else{
      fCfgFile << "0" << endl;
    }
	fCfgFile.close();
  }
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void CDMM750Dlg::OnButtonshow() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
 CString oFileName="Scp1.log";
 CString outFileName="Scp1.bmp";

  if(GetDataFromBuffer()){
    //AfxMessageBox("Es ging!");
  }else
    AfxMessageBox("Es ging nicht!");
  if(ConvertPrinterData2Pixels()){
    //AfxMessageBox("Es ging wieder!");
  }else
    AfxMessageBox("Es ging aber jetzt nicht!");
  m_bm.bmType=0;
  m_bm.bmWidth=160;
  m_bm.bmHeight=160;
  m_bm.bmWidthBytes=20;
  m_bm.bmPlanes=1;
  m_bm.bmBitsPixel=1;
  m_bm.bmBits=(LPVOID)&m_ucaPixels[0];

  DrawFrame();

  m_bmpBitmap.DeleteObject();
  m_bmpBitmap.CreateBitmapIndirect(&m_bm);

  m_dlgDisplay.Invalidate();

  SaveBitmapInFile(outFileName);
  // Ampel
  m_bmoAmpel.DeleteObject();
  m_bmoAmpel.LoadBitmap(IDB_BITM_YELLOW);
  m_bmoAmpel.GetObject(sizeof(m_bmAmpel),&m_bmAmpel);
  this->Invalidate();
}

//---------------------------------------------------------------------------
void CDMM750Dlg::OnButtonsave() 
{
 CSaveDlg oSaveDlg(this);
  oSaveDlg.DoModal();

  m_bmoAmpel.DeleteObject();
  m_bmoAmpel.LoadBitmap(IDB_BITM_YELLOW);
  m_bmoAmpel.GetObject(sizeof(m_bmAmpel),&m_bmAmpel);
  this->Invalidate();		
}

//---------------------------------------------------------------------------
void CDMM750Dlg::OnButtonreceive() 
{
	// Rx buffer initialisieren
  wDataBuffIdx = 0;
  // COM port oeffnen
  m_hCOM = CreateFile(LPCSTR(m_sCOMPort),
                      GENERIC_READ|GENERIC_WRITE,
                      0,0,OPEN_EXISTING,0,0);
  if(m_hCOM == INVALID_HANDLE_VALUE) {
    AfxMessageBox("Error: Open COM port!");  
  }else{
    //SetCommMask(m_hCOM,EV_RXCHAR);
    // Empfangs- und Sendepuffer Groesse
    SetupComm(m_hCOM,4096,0);
    // beendet alle laufenden Lese-/Schreiboperationen und loescht Puffer
    PurgeComm(m_hCOM,
              PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);
    // Aktuelle Einstellungen der Schnittstelle holen
    GetCommState(m_hCOM,&m_oDCB);
    // modifizieren
    m_oDCB.DCBlength = sizeof(DCB);

    m_oDCB.BaudRate = CBR_9600;
    m_oDCB.ByteSize = 8;
    m_oDCB.StopBits = ONESTOPBIT;
    m_oDCB.Parity =   NOPARITY;

    m_oDCB.fInX = m_oDCB.fOutX = 0;
    m_oDCB.fOutxDsrFlow = 0;
    m_oDCB.fDtrControl = DTR_CONTROL_ENABLE;
    m_oDCB.fOutxCtsFlow = 0;
    m_oDCB.fRtsControl = RTS_CONTROL_ENABLE;

    m_oDCB.fBinary = TRUE;
    m_oDCB.fParity = FALSE;

    SetCommState(m_hCOM,&m_oDCB);

   COMMTIMEOUTS oTimeouts;
    oTimeouts.ReadIntervalTimeout = MAXDWORD; // immediately return!
    oTimeouts.ReadTotalTimeoutMultiplier = 0;
    oTimeouts.ReadTotalTimeoutConstant = 0;
    oTimeouts.WriteTotalTimeoutMultiplier = 0;
    oTimeouts.WriteTotalTimeoutConstant = 0;
    SetCommTimeouts(m_hCOM,&oTimeouts);

    bCnnctd = TRUE;

    // Ampel
    m_bmoAmpel.DeleteObject();
    m_bmoAmpel.LoadBitmap(IDB_BITM_GREEN);
    m_bmoAmpel.GetObject(sizeof(m_bmAmpel),&m_bmAmpel);
    this->Invalidate();

    // thread starten
    m_hThread =
    CreateThread(
      (LPSECURITY_ATTRIBUTES)NULL,
      0,      // Stack wie Hauptthread
      (LPTHREAD_START_ROUTINE)ComWatchFct,
      (LPVOID)this, // Thread hat Zugriff auf CDMM750Dlg!
      0,
      &m_dwThreadID
    );
    SetThreadPriority(
      m_hThread, // handle to the thread
      THREAD_PRIORITY_NORMAL  // thread priority level
    );
    // tip: priority class of the process!
  }
}

//---------------------------------------------------------------------------
void CDMM750Dlg::OnButtonsettings() 
{
 CSettingsDlg oSettingsDlg(this);
  oSettingsDlg.DoModal();
  
}

/////////////////////////////////////////////////////////////////////////////
// secondary thread function
long WINAPI ComWatchFct(LPVOID _lpParam) {
 DWORD dwRead;
 BYTE ucRead;
 CDMM750Dlg* pDlg = (CDMM750Dlg*)_lpParam;

  while(bCnnctd) { // siehe Kommentar ganz oben
    ReadFile(pDlg->m_hCOM,&ucRead,1,&dwRead,NULL);
    if(dwRead > 0){
      // 1 Byte wurde gelesen
      aucDataBuff[wDataBuffIdx++] = ucRead;
      if( wDataBuffIdx >= MAX_BYTES_NBR){
        bCnnctd = FALSE;
        break;
      }
    }
  } // while(bCnnctd)...
  // buffer Inhalt pruefen
  if( (aucDataBuff[0xcfc]==0x0a &&
      aucDataBuff[0xcfd]==0x1b &&
      aucDataBuff[0xcfe]==0x33) ||
      (aucDataBuff[0xcfd]==0x0a && // im Win2000-PC ist Pufferinhalt
      aucDataBuff[0xcfe]==0x1b &&  // verschoben !!! (?)
      aucDataBuff[0xcff]==0x33)) {
    // Ampel
    pDlg->m_bmoAmpel.DeleteObject();
    pDlg->m_bmoAmpel.LoadBitmap(IDB_BITM_RED);
    pDlg->m_bmoAmpel.GetObject(sizeof(pDlg->m_bmAmpel),
                               &pDlg->m_bmAmpel);
    pDlg->Invalidate();
  }
  // COM port schliessen!
  CloseHandle(pDlg->m_hCOM);
  // Thread terminiert mit return!
  return 0;
}
